
-- # import Category

-- Functors ---------------------------------------------------------------

IsFunctor : (CC, DD  : Category) ->
	     (Map	      : CC.Object -> DD.Object) ->
	     (map     : (A, B : CC.Object) ->
			 CC.Arrow A B -> DD.Arrow (Map A) (Map B)) ->
	     Type
IsFunctor CC DD Map map =
    { !respId :
	(A : CC.Object) -> Eq (DD.Arrow (Map A) (Map A))
			       (map A A (CC.id A))
			       (DD.id (Map A))
    ; !respCompose :
	(A, B, C : CC.Object) ->
	(f : CC.Arrow B C) ->
	(g : CC.Arrow A B) ->
	Eq (DD.Arrow (Map A) (Map C))
	   (map A C (CC.compose A B C f g))
	   (DD.compose (Map A) (Map B) (Map C) (map B C f) (map A B g))
    }

Functor :  (CC, DD : Category) -> Type
Functor CC DD =
    { !Map    : CC.Object -> DD.Object
    ; !map    : (A, B : CC.Object) -> CC.Arrow A B -> DD.Arrow (Map A) (Map B)
    ; !proofs : IsFunctor CC DD Map map
    }

-- Natural transformations ------------------------------------------------
{-
IsNaturalTransformation :
    (CC, DD : Category)      ->
    (F, G   : Functor CC DD) ->
    (eta    : (A : CC.Object) ->
	       DD.Arrow (F.Map A) (G.Map A)
      ) ->
    Prop
IsNaturalTransformation CC DD F G eta =
  (A, B : CC.Object) ->
  (h	: CC.Arrow A B) ->
  Eq (DD.Arrow (F.Map A) (G.Map B))
     (DD.compose (F.Map A) (G.Map A) (G.Map B) (G.map A B h) (eta A))
     (DD.compose (F.Map A) (F.Map B) (G.Map B) (eta B) (F.map A B h))

NaturalTransformation :
    (CC, DD : Category)      ->
    (F, G   : Functor CC DD) ->
    Type
NaturalTransformation CC DD F G =
    { !eta	: (A : CC.Object) -> DD.Arrow (F.Map A) (G.Map A)
    ; !natural	: IsNaturalTransformation CC DD F G eta
    }
-}
