
-- # import Set
-- # import Rel
-- # import Prop

sig Setoid : Type extends SET where
  eq : EquivalenceRel (mkSET el)

mkSetoid : (A:SET) -> EquivalenceRel A -> Setoid
mkSetoid A eq = struct el = El A; eq = eq

infix 10 ==

(==) (A:Setoid) : El A -> El A -> PROP
(==) {A} = A.eq.rel

AntiSymmetric (A:Setoid) : Rel A -> PROP
AntiSymmetric R =
  ForAll $ \x -> ForAll $ \y ->
  R.rel x y  ==>  R.rel y x  ==>  x == y

sig AntiSymmetricRel (A:Setoid) : Type extends Rel where
  antisym : Prf (AntiSymmetric (mkRel rel))

RespectsEq (A:Setoid) : Rel A -> PROP
RespectsEq R =
  ForAll $ \x -> ForAll $ \y -> ForAll $ \z -> ForAll $ \w ->
    x == y  ==>  z == w  ==>  R.rel x z  ==>  R.rel y w

sig SetoidRel (A:Setoid) : Type extends Rel where
  respeq : Prf (RespectsEq (mkRel rel))

sig ReflexiveSetoidRel (A:Setoid) : Type
  extends ReflexiveRel, SetoidRel where

setoidRefl (A:Setoid) : (R:ReflexiveSetoidRel A) -> Prf (A.eq =<= R)
setoidRefl {A} R x y eqxy =
  R.respeq x x x y (A.eq.refl x) eqxy (R.refl x)

Irreflexive (A:Setoid) : Rel A -> PROP
Irreflexive R =
  ForAll $ \x -> ForAll $ \y ->
    x == y  ==>  Not (R.rel x y)

sig IrreflexiveRel (A:Setoid) : Type extends Rel where
  irrefl : Prf (Irreflexive (mkRel rel))

