-- Proofs about monads.
-- Author :: Ulf Norell
-- Created:: 2004-12-14

-- # import Property
-- # import Prelude.Proofs
-- # import Monad
-- # import Functor
-- # import EqualityReasoning

-- A monad is a functor ---------------------------------------------------

functorMonad : (M : Set -> Set) -> Monad M -> Functor M
functorMonad M monadM = struct
  map =  liftM M monadM.ops
  proofs = struct
    id      = \A -> fol-plugin(monadM.proofs.law1 A, extensionality)
    compose = \A B C f g ->
        let bindAB  = monadM.ops.bind A B
            bindBC  = monadM.ops.bind B C
            bindAC  = monadM.ops.bind A C
            retB    = monadM.ops.return B
            retC    = monadM.ops.return C
            (===)   = eqStep (M A -> M C)
        in
          extractProof (M A -> M C)
          ( beginEqProof (M A -> M C)

              (\m -> m `bindAC` \x -> retC (f (g x)))

                ===

              (\m -> m `bindAC` \x -> retB (g x) `bindBC` \y -> retC (f y))

                  `by` fol-plugin ( monadM.proofs.law2 B C, extensionality )

                ===
              
              (\m -> m `bindAB` (\x -> retB (g x)) `bindBC` \y -> retC (f y))

                  `by` assert-plugin()
                      {-fol-plugin ( monadM.proofs.law3 A B C
                                  , extensionality
                                  , __fol_pair_elimination
                                  , __fol_pair_injectivity
                                  )-}
          )
