-- Prelude, simple lambda calculus definitions.
-- Author :: Ulf Norell
-- Created:: 2004-12-14

-- All sets are inhabited
epsilon (A : Set) : A

id (A : Set) : A -> A
id x = x

-- function composition
infixl 20 <>
(<>) (A, B, C : Set) : (B -> C) -> (A -> B) -> A -> C
f <> g = \x -> f (g x)

-- function application
infixr 5 $
($) (A, B : Set) : (A -> B) -> A -> B
f $ x = f x

const (A, B : Set) : A -> B -> A
const x y = x

-- argument swapping
flip (A, B, C : Set) : (A -> B -> C) -> B -> A -> C
flip f = \x y -> f y x

Id : Set -> Set
Id = \A -> A

Const : Set -> Set -> Set
Const = \A B -> A

data Unit : Set where
  unit : Unit

