-- Properties (subjects of Agda -> FOL translation)
-- Authors:: Andreas Abel, Ulf Norell
-- Created:: 2005-04-04

Eq : (A : Set) -> A -> A -> Prop

reflexivity : (A:Set) -> (x:A) -> Eq A x x
reflexivity A = fol-plugin()

transitivity : (A:Set) -> (x,y,z : A) -> Eq A x y -> Eq A y z -> Eq A x z
transitivity A = fol-plugin()

symmetry : (A:Set) -> (x,y:A) -> Eq A x y -> Eq A y x
symmetry A = fol-plugin()

substitutivity : (A:Set) -> (P : A -> Prop) -> (x, y : A) ->
                  Eq A x y -> P x -> P y
substitutivity A P = fol-plugin()

congruence : (A, B : Set) -> (f : A -> B) -> (x, y : A) ->
                  Eq A x y -> Eq B (f x) (f y)
congruence A B f x y xy =
    substitutivity A  (\z -> Eq B (f x) (f z))
                      x y xy
                      (reflexivity B (f x))

-- connectives

True : Prop
tt : True

False : Prop

(==>) : Prop -> Prop -> Prop
p ==> q = p -> q

(<==) : Prop -> Prop -> Prop
p <== q = q ==> p

Not : Prop -> Prop
Not P = P ==> False

(/\) : Prop -> Prop -> Prop

-- Classical or
(\/) : Prop -> Prop -> Prop
P \/ Q = Not (Not P /\ Not Q)

(<=>) : Prop -> Prop -> Prop
P <=> Q = (P ==> Q) /\ (Q ==> P)

ForAll : (A:Set) -> (A -> Prop) -> Prop
ForAll A B = (x:A) -> B x

Exists : (A:Set) -> (A -> Prop) -> Prop
Exists A B = Not (ForAll A (\x -> Not (B x)))

infixl 4 /\
infixl 3 \/
infixr 2 ==>, <==
infix 1 <=>
