
module TypeChecker.Monad.Options where

import Control.Monad.Reader

import Interface.Options
import Interface.ChaseImports
import TypeChecker.Monad
import Utils.Monads

-- Options ----------------------------------------------------------------

commandLineOptions :: TC Options
commandLineOptions = envOptions <$> ask

isInteractive :: TC Bool
isInteractive = optInteractive <$> commandLineOptions

useThierryLet :: TC Bool
useThierryLet = optThierryLet <$> commandLineOptions

withUniversePolymorphism :: TC Bool
withUniversePolymorphism =
    optUniversePolymorphism <$> commandLineOptions

setCommandLineOptions :: Options -> TC a -> TC a
setCommandLineOptions opts =
    local $ \e -> e { envOptions = opts }

doSanityChecks :: TC Bool
doSanityChecks = optSanityCheck <$> commandLineOptions

findFile :: String -> [String] -> TC (Maybe FilePath)
findFile name exts =
    do	incs <- optIncludeDirs <$> commandLineOptions
	liftIO $ findModule incs name exts

verbose :: Int -> TC () -> TC ()
verbose n k =
    do	n' <- optVerbose <$> commandLineOptions
	when (n' >= n) k

