-- Kleene algebra, following Dexter Kozen

-- # import Property

D : Set
(+) : D -> D -> D
(<=) : D -> D -> Prop
(&) : D -> D -> D
star : D -> D
Zero : D
Eps : D

defLeq : (x:D) -> (y:D) -> (Eq D (x+y) y  <=>   x <= y)


axK : (x:D) -> (y:D) -> (z:D) ->
          (    Eq D (x + y) (y + x)
           /\  Eq D (x+ Zero) x
           /\  Eq D (x+ x) x
           /\  Eq D (x + (y+z)) ((x+y)+z)
           /\  Eq D (x & Eps) x
           /\  Eq D (Eps & x) x
           /\  Eq D (x & Zero) Zero
           /\  Eq D (Zero & x) Zero
           /\  Eq D (x & (y & z)) ((x & y) & z)
           /\  Eq D (Eps + (x & (star x))) (star x)
           /\  Eq D (Eps + ((star x) & x)) (star x))

rule1 : (x:D) -> (y:D) -> (z:D) -> y + (x & z) <= z ==> ((star x) & y) <= z
rule2 : (x:D) -> (y:D) -> (z:D) -> y + (z & x) <= z ==> (y & (star x)) <= z


transLeq : (x:D) -> (y:D) -> (z:D) -> x <= y /\ y <= z ==> x <= z
transLeq = \ x -> \ y -> \ z -> fol-plugin(defLeq,axK)

ref1Leq : (x:D) -> x <= x
ref1Leq = \ x -> fol-plugin(defLeq,axK)

ref2Leq : (x:D) -> (y:D) -> (x <= y /\ y <= x) -> Eq D x y
ref2Leq = \ x -> \ y -> \ h ->
          let
           rem1 : Eq D (x + y) y
           rem1 = fol-plugin(defLeq,h)
           rem2 : Eq D (y + x) x
           rem2 = fol-plugin(defLeq,h)
          in
           fol-plugin(rem1,rem2,axK)

refLeq : (x:D) -> (y:D) -> ((x <= y /\ y <= x) <=> Eq D x y)
refLeq = \ x -> \ y -> fol-plugin(ref1Leq,ref2Leq)

--- should not be accepted

lemConLeqL : (x:D) -> (y:D) -> (z:D) -> (z <= x ==> (z & y) <= (x & y))
lemConLeqL = \ x -> \ y -> \ z -> fol-plugin(defLeq,axK)

lemConLeqR : (x:D) -> (y:D) -> (z:D) -> (z <= x ==> (y & z) <= (y & x))
lemConLeqR = \ x -> \ y -> \ z -> fol-plugin(defLeq,axK)

